local modName = g_currentModName

MotorexInjector = {
    PREREQUISITES = {"motorized", "fillUnit", "drivable", "enterable"}
}

function MotorexInjector.prerequisitesPresent(typeEntry)
    local specs = typeEntry.specializationsByName
    for _, requirement in pairs(MotorexInjector.PREREQUISITES) do
        if specs[requirement] == nil then return false end
    end
    return true
end

function MotorexInjector.finalizeTypes(self, ...)
    if self.typeName == "vehicle" then
        -- Loop over all types
        for typeName, typeEntry in pairs(self:getTypes()) do
            if MotorexInjector.prerequisitesPresent(typeEntry) then
                self:addSpecialization(typeName, modName .. ".engineOilAddon")
                Logging.info(
                    "Mod %s: Added specialization engineOilAddon for vehicle type %s.",
                    modName, typeName)
            end
        end
    end
end

TypeManager.finalizeTypes = Utils.prependedFunction(TypeManager.finalizeTypes,
                                                    MotorexInjector.finalizeTypes)
